unit ConnectTo1Cv7;
interface
{*****************************************************
27.08.2007
http://d1cv8.narod.ru/top_003/d1cv8_20070827_001/d1cv8_20070827_001.htm
-  :
  "Delphi  1:.  "
-3 .19-25,
 4 .244-249,
-12,
-13

Delphi-,     1Cv7,
  
*****************************************************}

uses
  sp_Lib_Delphi,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TConnectTo1Cv7 = class(TComponent)
  private
    { Private declarations }

    //:
    // true -    1: ,
    //   - false
    fActive    : boolean;

    //  1:,   OLE Automation
    fole1Cv7   : oleVariant;

    //--------------------------------------------------
    //  1:

    //   1:
    fInitStr  : string;

    //  1:,   OLE Automation
    fAppName  : string;

    // ()    1
    //(  )
    fDirName  : string;

    // 
    fUserName : string;

    // () 
    fUserDir : string;

    //   
    fPSW      : string;

    //:  true -   
    fMono           : boolean;

    //:  true -   1:
    //    .
    fNo_Splash_Show : boolean;
    //--------------------------------------------------

    //  ,   
    //   1Cv7
    fKeyNameInReg : string;

    //    
    //(  )
    fDirTMP : string;

    //--------------------------------------------------
    //   1Cv7

    //:  true -  ,
    //   - 
    fVisible1Cv7 : boolean;

    //   1Cv7
    fhWnd1Cv7    : HWND;

    //     ,
    // ,    1Cv7
    fVisible1Cv7_Caption : string;
    //--------------------------------------------------
                      

  protected
    { Protected declarations }

    //   
    // 1: ( . 19-20 ).
    procedure BuildInitStr;

    //,   ()  1Cv7,
    //  
    procedure mSetActive(Value : boolean);

    //, ""    fVisible1Cv7
    procedure mSetVisible1Cv7(Value : boolean);

    //, ""    fAppName
    procedure mSetAppName(Value : string);

    //, ""    fDirName
    procedure mSetDirName(Value : string);

    //, ""    fUserName
    procedure mSetUserName(Value : string);

    //, ""    fUserDir
    procedure mSetUserDir(Value : string);

    //, ""    fPSW
    procedure mSetPSW(Value : string);

    //, ""    fMono
    procedure mSetMono(Value : boolean);

    //, ""    fKeyNameInReg
    procedure mSetKeyNameInReg(Value : string);

    //, ""    fDirTMP
    procedure mSetDirTMP(Value : string);

    

  public
    { Public declarations }

    //""  fole1Cv7,   (  )
    property ole1Cv7: oleVariant read fole1Cv7;

    //""  fhWnd1Cv7,   (  )
    property hWnd1Cv7: HWND read fhWnd1Cv7;


    //""  fInitStr,   (  )
    property InitStr: string read fInitStr;

    //  (  TComponent)
    constructor Create(AOwner: TComponent); override;
    //  (  TComponent)
    destructor Destroy; override;

    //,    1Cv7
    function ShowThisWindow_1Cv7 : boolean;

    //,    1Cv7
    function HideThisWindow_1Cv7 : boolean;

    //,       1Cv7
    //( .  12 )
    function Load_ListDB_1Cv7_from_Registry(ListDB : TStrings; YesDetect_1Cv7md : boolean) : integer;

    //,        1Cv7
    //( .  13 )
    function Load_ListActiveUsers_1Cv7(ListUsers : TStrings; YesCopyToDirTMP : boolean) : integer;


  published
    { Published declarations }

    // Active 
    //( ()  1Cv7,  )
    property Active: boolean read fActive write mSetActive;

    // Visible1Cv7 (/   1Cv7)
    property Visible1Cv7: Boolean read fVisible1Cv7 write mSetVisible1Cv7 default FALSE;

    // Visible1Cv7_Caption (    ,
    // ,    1Cv7)
    property Visible1Cv7_Caption: string read fVisible1Cv7_Caption write fVisible1Cv7_Caption;

    //  1:,   
    property AppName1Cv7: string read fAppName write mSetAppName;

    // ()    1
    property DirNameDB: string read fDirName write mSetDirName;

    // 
    property UserName: string read fUserName write mSetUserName;

    // () 
    property UserDir: string read fUserDir write mSetUserDir;

    //   
    property Password: string read fPSW write mSetPSW;

    //  
    property Mono: Boolean read fMono write mSetMono default FALSE;

    // ()  
    //  1Cv7  
    property No_Splash_Show: Boolean read fNo_Splash_Show write fNo_Splash_Show default FALSE;

    //  ,       1Cv7
    property KeyNameInReg: string read fKeyNameInReg write mSetKeyNameInReg;

    //    
    property DirNameTMP: string read fDirTMP write mSetDirTMP;

  end;



procedure Register;

implementation

constructor TConnectTo1Cv7.Create(AOwner: TComponent);
// 
begin
  // (   "")  " "  :)
  inherited Create(AOwner);

  fDirTMP:=Trim(fDirTMP);

  fKeyNameInReg:=Trim(fKeyNameInReg);
  if length(fKeyNameInReg)<=0 then fKeyNameInReg:='Software\1C\1CV7\7.7\Titles';

  //---------------------------------------
  //    
  fole1Cv7:=UnAssigned;
  fActive := FALSE;
  fMono:=FALSE;
  fNo_Splash_Show:=FALSE;
  fVisible1Cv7 := FALSE;
  fhWnd1Cv7    := 0;
  fVisible1Cv7_Caption := Trim(fVisible1Cv7_Caption);
  if length(fVisible1Cv7_Caption)<=0 then fVisible1Cv7_Caption:='1:';
  //---------------------------------------

  //  
  BuildInitStr;


end;


destructor TConnectTo1Cv7.Destroy;
// 
begin

  //  1:,
  //  
  fole1Cv7:=UnAssigned;

  fActive := FALSE;

  // (   )  " "  :)
  inherited Destroy;
end;


procedure TConnectTo1Cv7.BuildInitStr;
//    1:
begin
 fInitStr:='';

 fAppName:=Trim(fAppName);
 if length(fAppName)<=0 then fAppName:='V77.Application';
 fDirName:=Trim(fDirName);
 fUserName:=Trim(fUserName);
 fUserDir:=Trim(fUserDir);
 fPSW:=Trim(fPSW);

 if fMono then fInitStr:=fInitStr+' '+'/M';
 if length(fDirName)>0  then fInitStr:=fInitStr+' '+'/D'+fDirName;
 if length(fUserName)>0 then fInitStr:=fInitStr+' '+'/N'+fUserName;
 if length(fUserDir)>0  then fInitStr:=fInitStr+' '+'/U'+fUserDir;
 if length(fPSW)>0  then fInitStr:=fInitStr+' '+'/P'+fPSW;

 fInitStr:=Trim(fInitStr);

end;


procedure TConnectTo1Cv7.mSetActive(Value : boolean);
begin
  if Value<>fActive then begin
     //  1:,
     //  
     //(   ,   1Cv7     )
     fole1Cv7:=UnAssigned;
     fActive := FALSE;
     //  
     BuildInitStr;
     if Value then begin
        Screen.Cursor:=crHourGlass;
        TRY
          if fNo_Splash_Show then begin
             fole1Cv7:=ConnectTo1C(fInitStr,'NO_SPLASH_SHOW');
          end
          else begin
             fole1Cv7:=ConnectTo1C(fInitStr,'');
          end;
          if YesLinkToVariant(fole1Cv7) then begin
             fActive := TRUE;
          end;
        FINALLY
          Screen.Cursor:=crDefault;
        END;
     end;
  end;
end;


function TConnectTo1Cv7.ShowThisWindow_1Cv7 : boolean;
begin
  Result:=FALSE;
  fVisible1Cv7_Caption := Trim(fVisible1Cv7_Caption);
  if length(fVisible1Cv7_Caption)<=0 then fVisible1Cv7_Caption:='1:';
  if fActive then begin
     fVisible1Cv7:=FALSE;
     //    1  
     //    1
     fhWnd1Cv7:=sp_GetHandleThisWindow(fVisible1Cv7_Caption,1,TRUE,TRUE);
     if fhWnd1Cv7>32 then begin
        ShowWindow(fhWnd1Cv7,SW_SHOW);
        fVisible1Cv7:=TRUE;
        Result:=TRUE;
     end
     else begin
        fhWnd1Cv7:=0;
        ShowMessage('   1   !');
     end;
  end;
end;

function TConnectTo1Cv7.HideThisWindow_1Cv7 : boolean;
begin
  Result:=FALSE;
  fVisible1Cv7:=FALSE;
  if fhWnd1Cv7>32 then begin
     //    1
     ShowWindow(fhWnd1Cv7,SW_HIDE);
     Result:=TRUE;
  end;
end;



function TConnectTo1Cv7.Load_ListDB_1Cv7_from_Registry(ListDB : TStrings; YesDetect_1Cv7md : boolean) : integer;
//,       1Cv7
begin
  fKeyNameInReg:=Trim(fKeyNameInReg);
  if length(fKeyNameInReg)<=0 then fKeyNameInReg:='Software\1C\1CV7\7.7\Titles';
  // .    sp_Lib_Delphi
  Result:=Load_ListDB_from_Registry(fKeyNameInReg,ListDB,YesDetect_1Cv7md);
end;


function TConnectTo1Cv7.Load_ListActiveUsers_1Cv7(ListUsers : TStrings; YesCopyToDirTMP : boolean) : integer;
//,        1Cv7
Var
  Dir : string;
  fn_Links_tmp : string;
begin
  Result:=0;
  //   ,   
  //  
  Dir:=fDirName;
  if length(Dir)>0 then begin
     if Dir[length(Dir)]<>'\' then Dir:=Dir+'\';
     //    links.tmp
     fn_Links_tmp:=Dir+SubDir_SYSLOG+NameLinksTMP;
     // .    sp_Lib_Delphi
     Get_List_ActiveUsers_from_1C(fDirTMP,
                                  fn_Links_tmp,
                                  ListUsers,
                                  YesCopyToDirTMP);
     Result:=Exctract_UserName_from_ListActiveUsers(ListUsers);
  end;
end;



procedure TConnectTo1Cv7.mSetAppName(Value : string);
//    AppName1Cv7
begin
 fole1Cv7:=UnAssigned;
 fActive := FALSE;
 fAppName:=Value;
 BuildInitStr;
end;

procedure TConnectTo1Cv7.mSetVisible1Cv7(Value : boolean);
//    fVisible1Cv7
begin
  if Value then begin
     ShowThisWindow_1Cv7;
  end
  else begin
     HideThisWindow_1Cv7;
  end;
end;


procedure TConnectTo1Cv7.mSetDirName(Value : string);
//    DirNameDB
begin
 Value:=Trim(Value);
 if AnsiUpperCase(Trim(fDirName))<> AnsiUpperCase(Trim(Value)) then begin
    fole1Cv7:=UnAssigned;
    fActive := FALSE;
 end;
 fDirName:=Value;
 BuildInitStr;
end;

procedure TConnectTo1Cv7.mSetUserName(Value : string);
//    UserName
begin
 fole1Cv7:=UnAssigned;
 fActive := FALSE;
 fUserName:=Value;
 BuildInitStr;
end;

procedure TConnectTo1Cv7.mSetUserDir(Value : string);
//    UserDir
begin
 fole1Cv7:=UnAssigned;
 fActive := FALSE;
 fUserDir:=Trim(Value);
 BuildInitStr;
end;



procedure TConnectTo1Cv7.mSetPSW(Value : string);
//    Password
begin
 fole1Cv7:=UnAssigned;
 fActive := FALSE;
 fPSW:=Value;
 BuildInitStr;
end;

procedure TConnectTo1Cv7.mSetMono(Value : boolean);
//    Mono
begin
 fole1Cv7:=UnAssigned;
 fActive := FALSE;
 fMono:=Value;
 BuildInitStr;
end;


procedure TConnectTo1Cv7.mSetKeyNameInReg(Value : string);
//    KeyNameInReg
begin
  fKeyNameInReg:=Trim(Value);
  if length(fKeyNameInReg)<=0 then fKeyNameInReg:='Software\1C\1CV7\7.7\Titles';
end;


procedure TConnectTo1Cv7.mSetDirTMP(Value : string);
//    DirNameTMP
begin              
  fDirTMP:=Trim(Value);
  if length(fDirTMP)>0 then begin
     if fDirTMP[length(fDirTMP)]<>'\' then fDirTMP:=fDirTMP+'\';
  end;
end;



//******************************************
procedure Register;
begin
  RegisterComponents('1Cv7', [TConnectTo1Cv7]);
end;

end.


